#define __VERSION_H


class abspath;

class varpath;


class version                                        /* version info of a file */
{
   public:

   WORD lang;                                                   /* language id */
   WORD cset;                                                 /* character set */
   DWORD os;                                                             /* os */
   DWORD prmtype;                              /* primary type (exe, dll, etc) */
   DWORD subtype;                         /* sub type (display, keyboard, etc) */
   DWORD verhi32;                                     /* high 32bit version no */
   DWORD verlo32;                                      /* low 32bit version no */

   char *getprmtypename()
   {
      return getprmtypename(prmtype);
   }
   char *getsubtypename()
   {
      return getprmtypename(subtype);
   }

   int getversion(abspath &path);

   static int compare(HWND owner, abspath &srcpath, varpath &dstpath);
   static char *getprmtypename(DWORD prmtype);
   static char *getsubtypename(DWORD subtype);
};


