#define __QINIMGR_H


#ifndef __FPATH_H
#include "fpath.h"
#endif



/* quick ini entry manager */
class qinimgr
{
   static char b[256];                               /* store string just read */

   public:

   stcpath file;

   void setfile(abspath &filex)
   {
      file.set(filex);
   }

   void wint(char sect[], char entry[], int  value);
   void wstr(char sect[], char entry[], char value[]);
   void wlng(char sect[], char entry[], LONG value);
   void wfmt(char sect[], char entry[], char fmt[], ...);
   void wint(char sect[], int  entry,   int  value);
   void wstr(char sect[], int  entry,   char value[]);
   void wlng(char sect[], int  entry,   LONG value);
   void wfmt(char sect[], int  entry,   char fmt[], ...);

   int rint  (char sect[], char entry[], int def = 0);
   int rint  (char sect[], int  entry,   int def = 0);
   void rstr (char sect[], char entry[], char value[], char def[] = "");
   void rstr (char sect[], int  entry,   char value[], char def[] = "");
   LONG rlng (char sect[], char entry[], LONG def = 0L);
   LONG rlng (char sect[], int  entry,   LONG def = 0L);
   char *rstr(char sect[], char entry[]);
   char *rstr(char sect[], int  entry);
};

